#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <string.h>
#include <winioctl.h>
#include "SID6581_usr.h"

static HANDLE find_SID(char *namebuffer,unsigned int unit_number,int open_overlapped);

const char *mainprog(unsigned int numargs,const char **args,HANDLE devicehandle,int df)
{
  const char *errtxt;
  unsigned char *buffer;
  DWORD did_read;
  unsigned int t;
	errtxt=0L;

	buffer=(unsigned char*)malloc(0x00010000UL);
	if(!buffer)goto leave;

	//set freq of voice 1
	buffer[ 0]=0+14;	//freq low
	buffer[ 1]=0;
	buffer[ 2]=1+14;	//freq high
	buffer[ 3]=32;
	buffer[ 4]=2+14;	//pulse-width low
	buffer[ 5]=0xFF;
	buffer[ 6]=3+14;	//pulse-width high (4bit)
	buffer[ 7]=0x7;
	buffer[ 8]=4+14;	//waveform
	buffer[ 9]=0x40;
	buffer[10]=5+14;	//attack/decay
	buffer[11]=0x2A;
	buffer[12]=6+14;	//sustain/release
	buffer[13]=0x8A;
	buffer[14]=24;	//volume
	buffer[15]=0x0A;


	printf("setting up voice 1\n");
	if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,16,0L,0UL,&did_read,0L))
		printf("peek/poke failed.\n");

	buffer[0]=4+14;	//waveform
	buffer[1]=0x41;
	printf("playing voice 1\n");
	if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,2,0L,0UL,&did_read,0L))
		printf("peek/poke failed.\n");


	for(t=0UL;t<100UL;t++)
	{
		buffer[0]=SID_CMD_READ;
		buffer[1]=27;
		if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,2,buffer,1,&did_read,0L))
			{printf("peek failed.\n");break;}
		else
			if(did_read>0)
				printf(" $%02X",(unsigned int)buffer[0]);
	}
	printf("\n");


	Sleep(1000);

	buffer[0]=4+14;	//waveform
	buffer[1]=0x80;
	printf("stopping voice 1\n");
	if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,2,0L,0UL,&did_read,0L))
		printf("peek/poke failed.\n");

	Sleep(1000);

	//start timer
	t=1000*20;
	if(DeviceIoControl(devicehandle,SID_SET_TIMER,&t,sizeof(unsigned int),0L,0UL,&did_read,0L))
	{
		printf("playing some strokes.\n");


		//periodially play a number of times
		buffer[ 0]=4+14;	//waveform
		buffer[ 1]=0x81;
		buffer[ 2]=SID_CMD_TIMER;
		buffer[ 3]=0;
		buffer[ 4]=4+14;	//waveform
		buffer[ 5]=0x80;
		buffer[ 6]=SID_CMD_TIMER;
		buffer[ 7]=0;
		buffer[ 8]=SID_CMD_TIMER;
		buffer[ 9]=0;
		buffer[10]=SID_CMD_TIMER;
		buffer[11]=0;

		for(t=0UL;t<20;t++)
		{
			if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,12,0L,0UL,&did_read,0L))
				{printf("peek/poke failed.\n");break;}
		}
	}

/*
	t=100;
	if(DeviceIoControl(devicehandle,SID_SET_TIMER,&t,sizeof(unsigned int),0L,0UL,&did_read,0L))
	{
		printf("fast timer test running...\n");

		for(t=0UL;t<8192;t++)
		{
			buffer[(t<<3)+0]=SID_CMD_TIMER;
			buffer[(t<<3)+1]=0;
			buffer[(t<<3)+2]=24;
			buffer[(t<<3)+3]=0x0F;
			buffer[(t<<3)+4]=SID_CMD_TIMER;
			buffer[(t<<3)+5]=0;
			buffer[(t<<3)+6]=24;
			buffer[(t<<3)+7]=0x00;
		}

		if(!DeviceIoControl(devicehandle,SID_SID_PEEK_POKE,buffer,1024,0L,0UL,&did_read,0L))
			printf("peek/poke failed.\n");


		Sleep(2500UL);
		DeviceIoControl(devicehandle,SID_STOP_TIMER,0L,0UL,0L,0UL,&did_read,0L);
	}
*/


	DeviceIoControl(devicehandle,SID_STOP_TIMER,0L,0UL,0L,0UL,&did_read,0L);

leave:
	if(buffer)free(buffer);

	return errtxt;
}




int main(unsigned int numargs,const char **args)
{
  const char *errtxt;
  int result;
  const char *filename;
  unsigned int t;
  const char *onearg;
  unsigned char *buffer;
  char devname[32];
  HANDLE devicehandle;
  unsigned int unit_number;
  int df;
	errtxt=0L;
	devicehandle=INVALID_HANDLE_VALUE;
	buffer=0L;
	filename=0L;
	unit_number=0;
	result=0;

	df=0;

	for(t=1UL;t<numargs;t++)
	{
		onearg=args[t];
		if(*onearg=='-')
		{
			if(!strcmp(onearg+1,"unit"))
			{
				t++;
				if(t>=numargs){errtxt="no value for 'unit'";}
				onearg=args[t];
				if( (*onearg!='0'&&*onearg!='1') || onearg[1] )
					{errtxt="'unit' must be 0 or 1";}
				unit_number=*onearg-'0';
			}else
			{
				errtxt="no switches supported";
				goto leave;
			}
		}else{
			if(filename){errtxt="too many filenames specified";goto leave;}
			filename=onearg;
		}
	}

	devicehandle=find_SID(devname,unit_number,0);
	if(devicehandle==INVALID_HANDLE_VALUE)
	{
		errtxt="cannot open SID6581 device";goto leave;
	}else{
		printf("found SID device for unit %u, name '%s'\n",unit_number,devname);
	}

	errtxt=mainprog(numargs,args,devicehandle,df);



leave:
/*
	if(devicehandle&&buffer)
	{
		if(!DeviceIoControl(devicehandle,CW_GET_DEBUGTEXT,buffer,BUFFERSIZE-1,buffer,BUFFERSIZE-1,&did_read,0L))
			printf("get debugtext failed.\n");
		else{
			printf("debugtext:\n");
			buffer[did_read]=0;
			printf("%s",buffer);
		}
	}
*/
	if(devicehandle!=INVALID_HANDLE_VALUE)CloseHandle(devicehandle);
	if(errtxt)
	{
		if(!result)result=1;
		printf("Error: '%s'\n",errtxt);
	}
	return result;
}

static HANDLE find_SID(char *namebuffer,unsigned int unit_number,int open_overlapped)
{
  char devname[32];
  unsigned int t,len;
  HANDLE file;
  unsigned int ovl_flag;
	ovl_flag=( open_overlapped ? FILE_FLAG_OVERLAPPED : 0UL );
	for(t=0UL;t<4UL;t++)
	{
		len=sprintf(devname,"\\\\.\\SID6581_%u",t);
		file=CreateFile(devname,GENERIC_READ,FILE_SHARE_WRITE|FILE_SHARE_READ,0L,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL|ovl_flag,0L);
		if(file!=INVALID_HANDLE_VALUE)
		{
			if(!unit_number)
			{
				strcpy(namebuffer,devname);
				return file;
			}else{
				CloseHandle(file);
				unit_number--;
			}
		}
	}
	return INVALID_HANDLE_VALUE;
}
