/*
  sid (c) 1999-2004 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /code/cw/sid/defines.h,v 1.6 2004/05/14 14:51:03 doj Exp $
*/

#ifndef DEFINES__H
#define DEFINES__H

#include <stdint.h>

typedef uint8_t  byte;
typedef uint16_t word;
typedef uint32_t dword;
typedef uint64_t qword;

/// character to show a 1 bit
#define BITtrue  '*'
/// character to show a 0 bit
#define BITfalse '-'

/// this is the 12th root of 2 = pow(2.0, 1.0/12.0)
#define WURZ12OF2 1.0594630943592953098431053149397484958171844482421875

/// @return word value from bytes lo and hi
inline word lohi(const byte lo, const byte hi)
{
  return lo|(hi<<8);
}

#endif
