/*
  sid (c) 1999-2004 by Dirk Jagdmann <doj@cubic.org>

  This file is part of sid.

  sid is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your
  option) any later version.

  sid is distributed in the hope that it will be useful, but WITHOUT
  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public
  License for more details.

  You should have received a copy of the GNU General Public License
  along with sid; if not, write to the Free Software Foundation, Inc.,
  59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
  
  $Header: /code/cw/sid/mus.hh,v 1.6 2004/05/14 14:51:04 doj Exp $
*/

#ifndef MUS__HH
#define MUS__HH

#include <stdio.h>
#include "psid.h"

/**
   check if f contains a .mus file.

   @param f stdio file containing a .mus file.
   @return true if f contains a .mus file, false otherwise.
*/
bool isMUS(FILE *f);

/**
   load a .mus and optional .str into mem. The .mus and possibly .str
   file are loaded into mem along with the playroutines.

   @param f stdio file containing a .mus file.
   @param f2 stdio file containing a .str file. 0 if no .str should be loaded.
   @param mem pointer to a 64K memory block. 
   @return pointer to psid structure, correctly initialized for usage with mem. If there were any errors in loading the files 0 is returned. The caller must delete the returned struct.
 */
psid* loadMUS(FILE *f, byte *mem, FILE *f2=0);

/**
   install .mus and optional .str data along with a player into memory.

   @param ps pointer to psid structure, which will be set with correct loadAddr, initAddr etc.
   @param mem pointer to 64K memory block, were music and player will be copied to.
   @param buffer buffer containing .mus data
   @param size size of buffer
   @param buffer2 buffer containing .str data
   @param size2 size of buffer2
*/
int installMUS(psid *ps, byte *mem, byte *buffer, const size_t size, byte *buffer2=0, const size_t size2=0);

#endif
